// NFC [NHN Foundation Class]
//
//
// Copyright (C) 2006, nhn corp
// All rights reserved.

// $Id: Mutex.cpp,v 1.2 2006/07/29 06:09:22 taekwonv Exp $

#include "stdafx.h"
#include "Mutex.h"

using namespace nfc;

#if defined(WIN32)

CMutex::CMutex()
{
	::InitializeCriticalSection(&m_hMutex);
}

CMutex::~CMutex()
{
	::DeleteCriticalSection(&m_hMutex);
}

void CMutex::Lock()
{
	::EnterCriticalSection(&m_hMutex);
}

void CMutex::Unlock()
{
	::LeaveCriticalSection(&m_hMutex);
}

void CMutex::SetRecursive()
{
	
}
#endif // #if defined(WIN32)


#if defined(__NFC_LINUX__) || defined(__NFC_FREEBSD__) || defined(__APPLE_CC__) || defined(ANDROID)  

CMutex::CMutex()
{
	int ret = pthread_mutex_init( &m_hMutex, NULL );
	ASSERT( 0 == ret );
	
	//printf( "[%08X][%08X] Mutex::Mutex() mutex=%d\n", pthread_self(), this, mutex.__sig );
	
}

CMutex::~CMutex()
{
	//printf( "[%08X][%08X] Mutex::~Mutex()\n", pthread_self(), this );
	
	pthread_mutex_destroy(&m_hMutex);
}

void CMutex::SetRecursive()
{
	pthread_mutexattr_t   mta;
	int rc = 0;
	rc = pthread_mutexattr_init(&mta);
	ASSERT(rc == 0);
	rc = pthread_mutexattr_settype(&mta, PTHREAD_MUTEX_RECURSIVE);
	ASSERT(rc == 0);
	
	// re-create!
	pthread_mutex_destroy(&m_hMutex);
	
	pthread_mutex_init( &m_hMutex, &mta );
}

void CMutex::Lock()
{
	//printf( "[%08X][%08X] Mutex::Lock() mutex=%d\n", pthread_self(), this, mutex.__sig );
	
	int ret = pthread_mutex_lock(&m_hMutex);
	if(ret != 0 )
	{
		//printf("FATAL ERROR MUTEX\n");
	}
	ASSERT( 0 == ret );
}
void CMutex::Unlock()
{
	//printf( "[%08X][%08X] Mutex::Unlock()\n", pthread_self(), this );
	
	int ret = pthread_mutex_unlock(&m_hMutex);
	ASSERT( 0 == ret );
}


#endif // defined(__NFC_LINUX__) || defined(__NFC_FREEBSD__)